var db = new DB();
var all_field_types = ['varchar','tinyint','text','int','bigint'];
var defaultStroke = 1;
var defaultLineColor = '#000000';
var unique_tables = [];
var number_comp = ['&gt;=', '=', '&lt;=', '!='];
var char_comp = ['!=', '='];
var edges = [];

function drawLineBetweenBox(div1, div2)
{
  var pos1 = $('#'+div1).offset();  // Position relative to the document
  var pos2 = $('#'+div2).offset();
  var height1 = $('#'+div1).height();
  var height2 = $('#'+div2).height();
  var width1 = $('#'+div1).width();
  var center1x = pos1.left + width1;
  var center1y = pos1.top + (height1 / 2);
  var center2x = pos2.left;
  var center2y = pos2.top + (height2 / 2);
  var js = new jsGraphics('canvas');
  js.setColor(defaultLineColor);
  js.setStroke(defaultStroke);
  js.drawLine(center1x,center1y,center2x,center2y);
  js.paint();
}

function create_field_row(tbl_id, col_id, this_attribute)
{
  var field_name = '';
  var field_type = '';
  var field_value = '';
  var field_is_pri_key = 0;
  var field_is_auto_inc = 0;
  if(this_attribute != null)
  {
    field_name = this_attribute.get_field_name();
    field_type = this_attribute.get_field_type();
    field_value = this_attribute.get_field_value();
    field_is_pri_key = this_attribute.get_index_type();
    field_is_auto_inc = this_attribute.get_auto_increment();
  }
  var new_field_row = '<tr class="attr_row" id="row_'+col_id+'">';
  new_field_row += '<td id="row_'+col_id+'_field"><input type="text" id="row_'+col_id+'_field_val" size="15" value="'+field_name+'" /></td>';
  new_field_row += '<td id="row_'+col_id+'_type"><select id="row_'+col_id+'_type_val">';
  for(j in all_field_types)
  {
    new_field_row += '<option value="'+all_field_types[j]+'" ';
    if(all_field_types[j] == field_type)
      new_field_row += ' selected="selected"';
    else
      new_field_row += '';
    new_field_row += '>'+all_field_types[j].toUpperCase()+'</option>';
  }
  new_field_row += '</td>';
  new_field_row += '<td id="row_'+col_id+'_length"><input type="text" id="row_'+col_id+'_length_val" size="5" value="'+field_value+'" /></td>';
  
  new_field_row += '<td id="row_'+col_id+'_prikey"><input type="checkbox" id="row_'+col_id+'_prikey_val" ';
  if(field_is_pri_key)
    new_field_row += 'checked="checked"';
  new_field_row += ' /></td>';
  
  new_field_row += '<td id="row_'+col_id+'_autoinc"><input type="checkbox" id="row_'+col_id+'_autoinc_val" ';
  if(field_is_auto_inc)
    new_field_row += 'checked="checked"';
  new_field_row += ' /></td>';
  
  new_field_row += '<td><a href="" onclick="remove_row('+col_id+');return false;">[X]</a></td></tr>';
  
  
  //var new_field_row = '<tr class="attr_row" id="row_'+col_id+'"><td id="row_'+col_id+'_field"><input type="text" id="row_'+col_id+'_field_val" size="15" /></td><td id="row_'+col_id+'_type"><select id="row_'+col_id+'_type_val"><option value="varchar">VARCHAR</option><option value="tinyint">TINYINT</option><option value="text">TEXT</option><option value="int">INT</option><option value="bigint">BIGINT</option></select></td><td id="row_'+col_id+'_length"><input type="text" id="row_'+col_id+'_length_val" size="5" /></td><td id="row_'+col_id+'_prikey"><input type="checkbox" id="row_'+col_id+'_prikey_val" /></td><td id="row_'+col_id+'_autoinc"><input type="checkbox" id="row_'+col_id+'_autoinc_val" /></td><td><a href="" onclick="remove_row('+col_id+');return false;">[X]</a></td></tr>';
  $('#'+tbl_id).append(new_field_row);
  $('#tbl_design_field_count').val(parseInt(col_id) + 1);
  return new_field_row;
}

function remove_row(row_id)
{
  $('#row_'+row_id).fadeOut('slow', function() {
    $('#row_'+row_id).remove();
  });
}

function delete_table(tbl_name)
{
  var yes_to_del = confirm('Do you really want to delete table '+tbl_name+'?');
  if(yes_to_del)
  {
    $('#'+tbl_name+'_tbl').fadeOut('slow', function() {
      db.delete_table(tbl_name);
      $('#'+tbl_name+'_tbl').remove();
      alert('Table '+tbl_name+' has been deleted successfully');
    });
  }
}

function show_edit_or_create_btn(is_in_edit_mode)
{
  if(is_in_edit_mode)
  {
    $('#tbl_design_row_create').hide();
    $('#tbl_design_row_save').show();
  }
  else
  {
    $('#tbl_design_row_create').show();
    $('#tbl_design_row_save').hide();
  }
}

function populate_tbl_design(tbl_name)
{
  var tbl_obj = db.find_table(tbl_name);
  if(tbl_obj == null)
    alert('Fatal Error! Table '+tbl_name+' is not found');
  else
  {
    $('#tbl_design_tbl_name_val').val(tbl_name);
    $('#tbl_design').show();
    show_edit_or_create_btn(1);
    var tbl_attrs = tbl_obj.get_all_attributes();
    $('#row_0_field_val').val(tbl_attrs[0].get_field_name());
    for(j in all_field_types)
    {
      if(all_field_types[j] == tbl_attrs[0].get_field_type())
      {
        $('#row_0_type_val').val(all_field_types[j]);
        break;
      }
    }
    if(tbl_attrs[0].get_index_type() == 1)
      $('#row_0_prikey_val').attr('checked', true);
    if(tbl_attrs[0].get_auto_increment() == 1)
      $('#row_0_autoinc_val').attr('checked', true);
    for(k = 1; k < tbl_attrs.length; k++)
    {
      var new_row = create_field_row(tbl_name, k, tbl_attrs[k]);
      $('#create_tbl').append(new_row);
    }
  }
  return false;
}

function save_tbl(is_in_edit_mode)
{
  var tbl_name = $('#tbl_design_tbl_name_val').val();
  if(tbl_name == '')
  {
    alert('Please enter the table name!');
    $('#tbl_design_tbl_name_val').focus();
  }
  else if(!is_in_edit_mode && db.find_table(tbl_name) != null)
  {
    alert('Sorry! But table '+tbl_name+' already exists!');
    $('#tbl_design_tbl_name_val').focus();
  }
  else
  {      
    var num_of_fields = $('#tbl_design_field_count').val();
    var new_tbl_div = '<div class="db_tbl" id="'+tbl_name+'_tbl"><div class="db_tbl_name"><span id="'+tbl_name+'_tbl_name">'+tbl_name+'</span><div class="fright"><a href="" title="Delete table" onclick="delete_table(\''+tbl_name+'\');return false;">[X]</a><a href="" title="Edit table" onclick="populate_tbl_design(\''+tbl_name+'\');return false;">[E]</a></div><div class="clear"></div></div><div class="db_attrs">';
    var new_tbl = new Table(tbl_name);
    $('#tbl_design_main .attr_row').each(function()
    {
      var i = $(this).attr('id').replace('row_','');
      var field_name = $('#row_'+i+'_field_val').val();
      if(field_name != '')
      {
        var field_type = $('#row_'+i+'_type_val').val();
        var field_value = $('#row_'+i+'_length_val').val();
        var pri_key = 1;
        var auto_inc = 1;
        var pri_key_class = ' db_attrs_row_pri_key';
        if(!$('#row_'+i+'_prikey_val').attr('checked'))
        {
          pri_key_class = '';
          pri_key = 0;
        }
        if(!$('#row_'+i+'_autoinc_val').attr('checked'))
          auto_inc = 0;
        new_tbl_div += '<div class="db_attrs_row'+pri_key_class+'" id="'+tbl_name+'_tbl_'+field_name+'">'+field_name+'</div>';
        var new_attr = new Attribute(field_name, field_type, field_value, pri_key, auto_inc);
        new_tbl.add_attribute(new_attr);
      }
    });
    new_tbl_div += '</div>';
    if(is_in_edit_mode)
    {
      $('#'+tbl_name+'_tbl').remove();
      db.delete_table(tbl_name);
    }
    $('#diagram_div').append(new_tbl_div);
    $('#'+tbl_name+'_tbl').draggable({ containment: 'parent' }).resizable();
    db.add_table(new_tbl);
    $('#tbl_design_main').html($('#tbl_design_template').html());
    $('.db_attrs_row').draggable({ helper:'clone'}).droppable({
      drop: function(ui, event)
      {
        //alert($(event.draggable).clone().attr("id"));
        //alert($(this).attr("id"));
        var source = $(event.draggable).clone().attr("id");
        var dest = $(this).attr("id");
        //var source_temp = source.split("_");
        //var dest_temp = dest.split("_");
        //drawLineBetweenBox(source, dest);
        //var rel = new Relationship(source_temp[0], dest_temp[0], source_temp[2], dest_temp[2]);
        //db.add_relationship(rel);
        //auto_create_fk(source_temp[0], dest_temp[0], dest_temp[2]);
        auto_create_fk(source,dest);
      }});
  }
}

function auto_create_fk(src_tbl_id, dest_tbl_id)
//function auto_create_fk(src_tbl,dest_tbl, dest_pk)
{
  var source_temp = src_tbl_id.split("_");
  var dest_temp = dest_tbl_id.split("_");
  var src_tbl = source_temp[0];
  var dest_tbl = dest_temp[0];
  //var rel = new Relationship(source_temp[0], dest_temp[0], source_temp[2], dest_temp[2]);
  var src_fk = source_temp[0]+'_'+dest_temp[0]+'_fk';
  new_tbl_div = '<div class="db_attrs_row db_attrs_row_fk" id="'+src_fk+'">'+src_fk+'</div>';
  var new_attr = new Attribute(src_fk, 'BIGINT', '','',0);
  new_attr.set_is_foreign_key(true);
  db.find_table(src_tbl).add_attribute(new_attr);
  $('#'+src_tbl+'_tbl .db_attrs').append(new_tbl_div);
  var rel = new Relationship(src_tbl, dest_tbl, src_fk, dest_temp[2]);
  db.add_relationship(rel);
  drawLineBetweenBox(src_fk, dest_tbl_id);
}

function export_tbls_to_sql_script()
{
  if(db.get_tbls_count() == 0)
    alert('Please create at least one table before exporting to SQL');
  else
  {
    var sql_statement = '';
    var all_tables = db.get_all_tables();
    for(t in all_tables)
    {
      var this_table = all_tables[t];
      sql_statement += 'create table '+this_table.get_table_name()+'<br /> (';
      var all_attributes = this_table.get_all_attributes();
      var num_attributes = all_attributes.length;
      for(a in all_attributes)
      {
        var this_attribute = all_attributes[a];
        sql_statement += this_attribute.get_field_name()+' '+this_attribute.get_field_type();
        if(this_attribute.get_field_value() != '')
          sql_statement += '('+this_attribute.get_field_value()+')';
        if(a != num_attributes - 1)
          sql_statement += ',';
        sql_statement += '<br />';
      }
      sql_statement += ');<br /><br />';
    }
      var all_relationships = db.get_all_relationships();
        for(t in all_relationships)
        {
          sql_statement += 'alter table '+all_relationships[t].get_source_tbl()+' add constraint fk_'+t+' foreign key '+all_relationships[t].get_source_tbl()+'('+all_relationships[t].get_source_key()+') references '+all_relationships[t].get_dest_tbl()+'('+all_relationships[t].get_dest_key()+');<br /><br />';
        }
        $('#dump_div').append(sql_statement);
  }
}

function construct_qbe_form()
{
  var rels = db.get_all_relationships();
  if(rels.length == 0) return;
  unique_tables = [];
  for(r in rels)
  {
    var from = rels[r].get_source_tbl();
    var to = rels[r].get_dest_tbl();
    if($.inArray(from, unique_tables) == -1)
      unique_tables.push(from);
      if($.inArray(to, unique_tables) == -1)
        unique_tables.push(to);
  }
  var qbe_form_tbl = '<table border="1"><tr id="tbl_name"><th>Table</th></tr><tr id="field_name"><th>Field</th></tr><tr id="field_alias"><th>Alias</th></tr><tr id="field_show"><th>Show</th></tr><tr id="field_sort"><th>SORT</th></tr><tr id="field_criteria"><th>Criteria</th></tr></table>';
  $('#qbe_form_tbl').html(qbe_form_tbl);
  for(tbl in unique_tables)
  {
    var this_tbl = db.find_table(unique_tables[tbl]);
    var this_tbl_name = this_tbl.get_table_name();
    var this_tbl_attrs = this_tbl.get_all_attributes();
    for(attr in this_tbl_attrs)
    {
      var this_attr = this_tbl_attrs[attr];
      if(!this_attr.get_is_foreign_key())
      {
        $('#qbe_form_tbl #tbl_name').append('<td id="tbl_'+this_tbl_name+'_'+attr+'">'+this_tbl_name+'</td>');
        var attr_name = this_attr.get_field_name();
        var attr_type = this_attr.get_field_type();
        $('#qbe_form_tbl #field_name').append('<td id="'+this_tbl_name+'_'+attr_name+'">'+attr_name+'</td>');
        $('#qbe_form_tbl #field_alias').append('<td><input type="text" id="'+this_tbl_name+'_'+attr_name+'_alias" /></td>');
        $('#qbe_form_tbl #field_show').append('<td><input type="checkbox" id="'+this_tbl_name+'_'+attr_name+'_Show" /></td>');
        $('#qbe_form_tbl #field_sort').append('<td><select id="'+this_tbl_name+'_'+attr_name+'_Sort"><option value="">&mdash;</option><option value="ASC">ascending</option><option value="DESC">descending</option></select></td>');
        var comp_select = '<select id="'+this_tbl_name+'_'+attr_name+'_Comp_Criteria">';
        if(attr_type == 'char' || attr_type == 'varchar')
        {
          for(comp in char_comp)
          {
            comp_select += '<option value="'+char_comp[comp]+'">'+char_comp[comp]+'</option>';
          }
        }
        else
        {
          for(comp in number_comp)
          {
            comp_select += '<option value="'+number_comp[comp]+'">'+number_comp[comp]+'</option>';
          }
        }
        comp_select += '</select>';
        $('#qbe_form_tbl #field_criteria').append('<td>'+comp_select+'&nbsp;<input type="text" size="10" id="'+this_tbl_name+'_'+attr_name+'_Criteria" /></td>');
      }
    }
  }
}

function create_sql_query()
{
  var rels = db.get_all_relationships();
  if(rels.length == 0)
  {
    alert('Please link at least two tables first!');
    return;
  }
  var show_fields = [];
  $('#field_show').children('td').each(function(index)
  {
    $(this).children('input').each(function(iindex)
    {
      var this_input = $(this).attr("id");
      var this_input_checked = $(this).attr("checked");
      if(this_input_checked)
      {
        var splitter = this_input.split('_');
        var this_column = splitter[0]+'.'+splitter[1];
        var this_column_alias = $('#'+splitter[0]+'_'+splitter[1]+'_alias').val();
        if(this_column_alias != '')
          this_column += ' as '+this_column_alias;
        show_fields.push(this_column);  
      }
    });
  });
  if(show_fields.length == 0)
    alert("Please select at least 1 field to display");
  else
  {
    var all_rels = [];
    for(r in rels)
    {
      var this_rel = rels[r];
      var this_source_tbl = this_rel.get_source_tbl();
      var this_dest_tbl = this_rel.get_dest_tbl();
      var this_source_key = this_rel.get_source_key();
      var this_dest_key = this_rel.get_dest_key();
      if(r > 0)
        all_rels += ' join '+this_dest_tbl+" on "+this_source_tbl+'.'+this_source_key+' = '+this_dest_tbl+'.'+this_dest_key;
      else
        all_rels = this_source_tbl+' join '+this_dest_tbl+" on "+this_source_tbl+'.'+this_source_key+' = '+this_dest_tbl+'.'+this_dest_key;
    }
    var sql_query = 'select ';
    sql_query += show_fields.join(', ') +' from '+all_rels;
    var criteria_fields = [];
    $('#field_criteria').children('td').each(function(index)
    {
      var this_comp = $($(this).children()[0]);
      var this_criteria = $($(this).children()[1]);
      var this_input_val = this_criteria.val();
      if(this_input_val != '')
      {
        var this_comp_val = this_comp.val();
        var splitter = this_criteria.attr("id").split('_');
        var this_attribute_type = db.find_table(splitter[0]).find_attribute(splitter[1]).get_field_type();
        if(this_attribute_type == 'char' || this_attribute_type == 'varchar')
          this_input_val = "'"+this_input_val+"'";
        criteria_fields.push(splitter[0]+'.'+splitter[1]+' '+this_comp_val+' '+this_input_val);
      }
    });
    if(criteria_fields.length > 0)
      sql_query += ' where '+criteria_fields.join(' and ')+' ';
    else
      sql_query += ' ';
    var sort_fields = [];
    $('#field_sort').children('td').each(function(index)
    {
      $(this).children('select').each(function(iindex)
      {
        var this_input = $(this).attr("id");
        var this_input_val = $(this).val();
        if(this_input_val != '')
        {
          var splitter = this_input.split('_');
          sort_fields.push(splitter[0]+'.'+splitter[1]+' '+this_input_val);
        }
      });
    });
    if(sort_fields.length > 0)
      sql_query += ' order by '+sort_fields.join(', ');
  }
  $('#dump_div').append(sql_query+'<br /><br />');
  return false;
}

$(document).ready(function(){
  $('#qbe_form').addClass('hided');  // Hide qbe form
  // Bind create table button
  $('#create_tbl_btn').bind('click', function() { show_edit_or_create_btn(0); });
  // Bind export table button
  $('#expt_tbl_sql').bind('click', function() { export_tbls_to_sql_script(); });
  // Bind add row button
  $('#tbl_design_row_add').bind('click',
  function(event)
  {
    create_field_row('create_tbl', $('#tbl_design_field_count').val(), null);
  });
  // Bind save button on create mode
  $('#tbl_design_row_create').bind('click',
  function(event)
  {
    save_tbl(0);
  });
  // Bind save button on edit mode
  $('#tbl_design_row_save').bind('click',
  function(event)
  {
    save_tbl(1);
  });
  // Bind create new table div onclick
  $('#create_new_tbl').bind('click',
  function(event)
  {
    $('#tbl_design').removeClass('hided');
    $('#qbe_form').addClass('hided');
  });
  // Bind create qbe div onclick
  $('#create_qbe').bind('click',
  function(event)
  {
    $('#tbl_design').addClass('hided');
    $('#qbe_form').removeClass('hided');
    construct_qbe_form();
  });
  // Bind create query button
  $('#b1').bind('click', function() { create_sql_query(); });
});
